using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


namespace P18_2
{
    public class modCls : Microsoft.Xna.Framework.DrawableGameComponent
    {
        //Модель
        public Model myModel;
        //Мировая матрица, матрицы вида и проекции
        public Matrix WorldMatrix;
        public Matrix ViewMatrix;
        public Matrix ProjectMatrix;
        //Соотношение сторон экрана
        public float aspectRatio;
        //Для управления графическим устройством
        GraphicsDeviceManager graphics;
        //Конструктор получает на вход 
        //игровой класс, модель, объект для управления графическим устройством
        public modCls(Game game, Model mod, GraphicsDeviceManager grf)
            : base(game)
        {
            myModel = mod;
            graphics = grf;
            aspectRatio = (float)graphics.GraphicsDevice.Viewport.Width /
(float)graphics.GraphicsDevice.Viewport.Height;
        }

        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here
            base.Initialize();
        }

        public override void Draw(GameTime gameTime)
        {

            foreach (ModelMesh mesh in myModel.Meshes)
            {
                //Для каждого эффекта в сети
                foreach (BasicEffect effect in mesh.Effects)
                {
                    //Установим освещение 

                    effect.AmbientLightColor = new Vector3(0.2f, 0.2f, 0.2f);
                    effect.DiffuseColor = new Vector3(1.0f, 1.0f, 1.0f);
                    effect.SpecularColor = new Vector3(0.25f, 0.25f, 0.25f);
                    effect.SpecularPower = 7.0f;
                    effect.LightingEnabled = true;


                    effect.DirectionalLight0.Enabled = true; // активируем каждый источник света отдельно
                    if (effect.DirectionalLight0.Enabled)
                    {
                        // Направление по Х
                        effect.DirectionalLight0.DiffuseColor = new Vector3(1, 0, 0); // диапазон от 0 до 1
                        effect.DirectionalLight0.Direction = Vector3.Normalize(new Vector3(-1, 0, 0));
                        // Направление от источника света к началу координат сцены
                        effect.DirectionalLight0.SpecularColor = Vector3.One;
                    }

                    effect.DirectionalLight1.Enabled = true;
                    if (effect.DirectionalLight1.Enabled)
                    {
                        // Направление по У
                        effect.DirectionalLight1.DiffuseColor = new Vector3(0, 0.75f, 0);
                        effect.DirectionalLight1.Direction = Vector3.Normalize(new Vector3(0, -1, 0));
                        effect.DirectionalLight1.SpecularColor = Vector3.One;
                    }

                    effect.DirectionalLight2.Enabled = true;
                    if (effect.DirectionalLight2.Enabled)
                    {
                        // Направление по Z
                        effect.DirectionalLight2.DiffuseColor = new Vector3(0, 0, 0.5f);
                        effect.DirectionalLight2.Direction = Vector3.Normalize(new Vector3(0, 0, -1));
                        effect.DirectionalLight2.SpecularColor = Vector3.One;
                    }
                    //установить матрицы
                    effect.World = WorldMatrix;
                    effect.View = ViewMatrix;
                    effect.Projection = ProjectMatrix;
                }
                mesh.Draw();
            }

            base.Draw(gameTime);
        }
    }

}
